﻿//////////////////////////////////////////////
// BlurComplexEffect.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class Program ;
	class Texture ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../../../Dll/DllDefines.h"

#include "../ComplexEffect.h"

#include "BlurComplexEffectInfo.h"

/// Class ------------------------------------

namespace nkAstraeus
{
	class DLL_ASTRAEUS_EXPORT BlurComplexEffect final : public ComplexEffect
	{
		private :

			// Attributes
			// Program
			BlurComplexEffectInfo _loadedInfo ;

			// Info
			BlurComplexEffectInfo _info ;

			// Resources
			nkGraphics::Texture* _firstPassTexture ;
			nkGraphics::Texture* _secondPassTexture ;

		private :

			// Functions
			// Program creations

			// Texture creations

		public :

			// Constructor, destructor
			BlurComplexEffect () ;
			~BlurComplexEffect () ;

			// Getters
			virtual COMPLEX_EFFECT_TYPE getType () const override ;
			nkGraphics::Texture* getSourceTexture () const ;
			nkGraphics::Texture* getOutputTexture () const ;

			// Setters
			void setSourceTexture (nkGraphics::Texture* value) ;
			void setSourceDepth (nkGraphics::Texture* value) ;

			// Load
			virtual bool load () override ;
			virtual void unload () override ;
	} ;
}