﻿//////////////////////////////////////////////
// DofComplexEffect.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkAstraeus
{
	class TextureCopyEffect ;
}

namespace nkGraphics
{
	class Program ;
	class Texture ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../../../Dll/DllDefines.h"

#include "../ComplexEffect.h"

#include "DofComplexEffectInfo.h"

/// Class ------------------------------------

namespace nkAstraeus
{
	class DLL_ASTRAEUS_EXPORT DofComplexEffect final : public ComplexEffect
	{
		private :

			// Attributes
			// Program
			DofComplexEffectInfo _loadedInfo ;

			// Info
			DofComplexEffectInfo _info ;

			// Resources
			TextureCopyEffect* _downSamplingEffect ;
			nkGraphics::Texture* _downSamplingTexture ;
			nkGraphics::Texture* _downSamplingBlurredTexture ;

		private :

			// Functions
			// Downsample effect creation
			TextureCopyEffect* _createDownSamplingEffect () ;

		public :

			// Constructor, destructor
			DofComplexEffect () ;
			~DofComplexEffect () ;

			// Getters
			virtual COMPLEX_EFFECT_TYPE getType () const override ;
			nkGraphics::Texture* getSourceTexture () const ;
			nkGraphics::Texture* getSourceDepth () const ;

			// Setters
			void setSourceTexture (nkGraphics::Texture* value) ;
			void setSourceDepth (nkGraphics::Texture* value) ;

			// Load
			virtual bool load () override ;
			virtual void unload () override ;
	} ;
}