﻿//////////////////////////////////////////////
// FxaaProgramTracker.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class Program ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../../Utils/ProgramTracker.h"

#include "FxaaEffectInfo.h"

// nkCommon
#include <nilkinsCommon/Patterns/SingletonClass.h>

// Standards
#include <unordered_map>

/// Internals --------------------------------

namespace nkAstraeus
{
	struct FxaaProgramIdGenerator
	{
		static unsigned long long generate (const FxaaEffectInfo& info) ;
	} ;

	struct FxaaProgramNameGenerator
	{
		constexpr static const char* name = "NILKINS_FXAA_PROGRAM_" ;
	} ;
}

/// Class ------------------------------------

namespace nkAstraeus
{
	class FxaaProgramTracker final : public ProgramTracker<FxaaEffectInfo, FxaaProgramIdGenerator, FxaaProgramNameGenerator>, public nkCommon::SingletonClass<FxaaProgramTracker>
	{
		friend class SingletonClass<FxaaProgramTracker> ;

		private :

			// Functions
			// Constructor, destructor
			FxaaProgramTracker () ;
			~FxaaProgramTracker () ;
	} ;
}