﻿//////////////////////////////////////////////
// ImageEnvironmentProgramTracker.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class Program ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../../Utils/ProgramTracker.h"

#include "ImageEnvironmentEffectInfo.h"

// nkCommon
#include <nilkinsCommon/Patterns/SingletonClass.h>

// Standards
#include <unordered_map>

/// Internals --------------------------------

namespace nkAstraeus
{
	struct ImageEnvironmentProgramIdGenerator
	{
		static unsigned long long generate (const ImageEnvironmentEffectInfo& info) ;
	} ;

	struct ImageEnvironmentProgramNameGenerator
	{
		constexpr static const char* name = "NILKINS_IMAGE_ENVIRONMENT_PROGRAM_" ;
	} ;
}

/// Class ------------------------------------

namespace nkAstraeus
{
	class ImageEnvironmentProgramTracker final : public ProgramTracker<ImageEnvironmentEffectInfo, ImageEnvironmentProgramIdGenerator, ImageEnvironmentProgramNameGenerator>, public nkCommon::SingletonClass<ImageEnvironmentProgramTracker>
	{
		friend class SingletonClass<ImageEnvironmentProgramTracker> ;

		private :

			// Functions
			// Constructor, destructor
			ImageEnvironmentProgramTracker () ;
			~ImageEnvironmentProgramTracker () ;
	} ;
}