﻿//////////////////////////////////////////////
// TextureCopyEffect.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class Program ;
	class Sampler ;
	class Texture ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../../../Dll/DllDefines.h"

#include "../Effect.h"

#include "TextureCopyEffectInfo.h"

/// Class ------------------------------------

namespace nkAstraeus
{
	class DLL_ASTRAEUS_EXPORT TextureCopyEffect final : public Effect
	{
		private :

			// Attributes
			// Program
			nkGraphics::Program* _program ;
			TextureCopyEffectInfo _programInfo ;

			// Info
			TextureCopyEffectInfo _info ;

		private :

			// Functions
			// Program
			bool _prepareProgram () ;

			// Shader
			bool _prepareShader () ;

		public :

			// Constructor, destructor
			TextureCopyEffect () ;
			~TextureCopyEffect () ;

			// Getters
			virtual EFFECT_TYPE getType () const override ;
			nkGraphics::Texture* getSourceTexture () const ;
			nkGraphics::Sampler* getSourceSampler () const ;

			// Setters
			void setSourceTexture (nkGraphics::Texture* value) ;
			void setSourceSampler (nkGraphics::Sampler* value) ;

			// Load
			virtual bool load () override ;
			virtual void unload () override ;
	} ;
}