﻿//////////////////////////////////////////////
// TextureCopyProgramTracker.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class Program ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../../Utils/ProgramTracker.h"

#include "TextureCopyEffectInfo.h"

// nkCommon
#include <nilkinsCommon/Patterns/SingletonClass.h>

// Standards
#include <unordered_map>

/// Internals --------------------------------

namespace nkAstraeus
{
	struct TextureCopyProgramIdGenerator
	{
		static unsigned long long generate (const TextureCopyEffectInfo& info) ;
	} ;

	struct TextureCopyProgramNameGenerator
	{
		constexpr static const char* name = "NILKINS_TEX_COPY_PROGRAM_" ;
	} ;
}

/// Class ------------------------------------

namespace nkAstraeus
{
	class TextureCopyProgramTracker final : public ProgramTracker<TextureCopyEffectInfo, TextureCopyProgramIdGenerator, TextureCopyProgramNameGenerator>, public nkCommon::SingletonClass<TextureCopyProgramTracker>
	{
		friend class SingletonClass<TextureCopyProgramTracker> ;

		private :

			// Functions
			// Constructor, destructor
			TextureCopyProgramTracker () ;
			~TextureCopyProgramTracker () ;
	} ;
}