﻿//////////////////////////////////////////////
// Compositor.h
//
//////////////////////////////////////////////

/// Defines / macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class CompositorNode ;
	class Texture ;
}

/// Includes ---------------------------------

// nkGraphics
#include "../Dll/DllDefines.h"

#include "../Resources/Resource.h"

// Export
#include <NilkinsExport/Exportable/Exportable.h>

// Standards
#include <vector>

/// Classe -----------------------------------

namespace nkGraphics
{
	class DLL_GRAPHICS_EXPORT Compositor : public Resource, public nkExport::Exportable
	{
		protected :
		
			// Attributs
			// Les noeuds composant notre chaîne de rendu
			std::vector<CompositorNode*> _renderChain ;
		
		public :
		
			// Constructeur, destructeur
			Compositor () ;
			virtual ~Compositor () ;

			// Manipulations nodes
			virtual CompositorNode* addNode () = 0 ;
			virtual void deleteNode (unsigned int index) ;
			virtual void changeNodeOrder (unsigned int fromIndex, unsigned int toIndex) ;
			virtual void clearNodes () ;

			// Getters
			unsigned int getNodeCount () const ;
			CompositorNode* getNode (unsigned int index) const ;

			// Resource
			virtual bool load () override ;
			virtual void unload () override ;

			// Rendering
			virtual void renderChain () ;

			// L'export et import
			virtual void exportClassToTree (nkExport::Node* rootNode) override ;
			virtual void importClassFromTree (nkExport::Node* rootNode) override ;
	} ;
}