﻿//////////////////////////////////////////////
// Dx11Viewport.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkGraphics
#include "../../../Viewports/Viewport.h"

/// Class ------------------------------------
	
namespace nkGraphics::gles
{
	class GlesViewport final : public nkGraphics::Viewport
	{
		private :

			// Attributes
			// Values
			int _x ;
			int _y ;
			int _width ;
			int _height ;

		public :
		
			// Constructor, destructor
			GlesViewport () ;
			~GlesViewport () ;

			// Getters
			virtual float getWidth () const override ;
			virtual float getHeight () const override ;
			virtual float getMinDepth () const override ;
			virtual float getMaxDepth () const override ;
			virtual float getTopLeftX () const override ;
			virtual float getTopLeftY () const override ;

			// Setters
			virtual void setWidth (float width) override ;
			virtual void setHeight (float height) override ;
			virtual void setMinDepth (float value) override ;
			virtual void setMaxDepth (float value) override ;
			virtual void setTopLeftX (float value) override ;
			virtual void setTopLeftY (float value) override ;

			// Activation
			void activate () ;
	} ;
}