﻿//////////////////////////////////////////////
// FileLogger.h
//
//////////////////////////////////////////////

/// Defines, macros --------------------------

#pragma once

/// Includes ---------------------------------

// nkLog
#include "Data/StringView.h"

#include "Dll/DllDefines.h"

#include "Logger.h"

// Standards
#include <fstream>
#include <string>

/// Class ------------------------------------
	
namespace nkLog
{
	class DLL_LOG_EXPORT FileLogger final : public Logger
	{
		private :
		
			// Attributes
			// Output info
			std::string _filePath ;
			std::ofstream _file ;
			
		public :
		
			// Constructor, destructor
			FileLogger (const StringView& filePath) ;
			~FileLogger () ;

			// Getters
			StringView getOutputFilePath () const ;

			// Setters
			void setOutputFilePath (const StringView& path) ;

			// Actions
			virtual void log (const StringView& message, const StringView& className) override ;
	} ;
}